struct BinaryReader
(
_f, -- binary file stream
_size,

fn Open srcPath = 
(
	_f = fopen srcPath  "rb"
	fseek _f 0 #seek_end
	_size = ftell _f
	fseek _f 0 #seek_set
	
	if (_f == undefined) then
	(
		messageBox ("Unable to open file " + srcPath)
		throw ("Unable to open file " + srcPath )
	)
	
	
	-- _size = substring _size 0 (_size.count - 1)
),

-- TODO: Dosn't work
fn EOF = 
(
	throw "NYI"
	return (ftell _f) >= _size
),

-- seek with an offset to the current position
fn SeekCur offset = 
(
	fseek _f offset #seek_cur
),

-- seek to an absolute position
fn SeekSet position = 
(
	fseek _f position #seek_set
),

fn Position = (return ftell _f),

fn GetByte = 
(
	return ReadByte _f #unsigned
),

-- get a string with a fixed size
fn ReadFixedLengthString len = 
(
	local strRead = ""
	for i = 1 to len do
		strRead += (bit.intAsChar (ReadByte _f ))
	
	return strRead
),

-- read a null terminated string from an absolute offset
fn ReadString offset = 
(
	local t = ftell _f
	fseek _f offset #seek_set
	
	local strRead = ""
	local ic = ReadByte _f
	local c = (bit.intAsChar ic)
	strRead += c
	while (ic != 0) do
	(
		ic = ReadByte _f
		c = (bit.intAsChar ic)
		strRead += c
	)
	
	fseek _f t #seek_set
	
	return strRead
),


-- 4 bytes, unsigned int
fn ReadDWORD = 
(
	local w1 = ReadByte _f #unsigned
	local w2 = ReadByte _f #unsigned
	local w3 = ReadByte _f #unsigned
	local w4 = ReadByte _f #unsigned
	
	local d = bit.or (bit.shift w1 24) (bit.shift w2 16) 
  	d = bit.or d (bit.shift w3 8)
  	d = bit.or d w4
  	return d
),

-- 2 bytes, unsigned short
fn ReadWORD =
(
  local w1 = ReadByte _f #unsigned
  local w2 = ReadByte _f #unsigned
  
  local w = bit.or (bit.shift w1 8) w2 -- w = (w1 << 8) | w2;
  
  if w < 0 then
  (
		messageBox "ReadWORD should be unsigned"
		throw "GetSHORT should be unsigned"
  )
	
  return w
),


-- returns string[]
fn ReadStringTable pos =
(
	oldPos = Position()
	SeekSet pos 
	count = ReadWORD() -- orig = 35 read = 35. current pos = ok?
	unknown1 = ReadWORD() -- skip pad bytes
	result = #()
	
	for i = 1 to count do
	(
		unknown = ReadWORD()
		stringOffset = ReadWORD()
		s = ReadString (pos + stringOffset)
		result[i] = s
	)
	SeekSet oldPos 
	return result
),

-- 2 bytes, signed short. Using two's complement
fn GetSHORT = 
(
	signedValue = ReadWORD() -- unsigned
	negativeSign = bit.get signedValue 16
	if (negativeSign) then
	(
		-- flip bits and add 1
		-- signedValue = bit.not signedValue // Dosn't work?
		signedValue = bit.xor signedValue 65535 -- 65535 == all 1's
		signedValue += 1
		signedValue = signedValue * -1
	)
		
	return signedValue
)
,

-- must reverse value for read. big endian [could also write / read from another file]
-- http://java.sun.com/j2se/1.3/docs/api/java/lang/Float.html#intBitsToFloat(int)
fn GetFloat =
(
	bits = ReadDWORD()
	s = -1
	if (bit.shift bits -31) == 0 then
		s = 1
		
	e = bit.and (bit.shift bits -23) 0xff 

 	m = 0
	if (e == 0) then
		m = bit.shift (bit.and bits 0x7fffff) 1
	else
		m = bit.or (bit.and bits 0x7fffff) 0x800000
		
	fx = s * m * (pow 2 (e-150))
	return fx 
)

)