fileIn ((GetDir #maxroot) + "\\Plugins\\MaxBMD\\BModel.ms")

macroScript BMDImporterUI category:"MaxBMD" tooltip:"Import BMD files" Icon:#("Maxscript", 2) ButtonText:"MaxBMD"
(
	-- note that the mactoscript itself defines a scope

	rollout MaxBMDUI_Rollout "BMD Importer"
	(
		edittext txtFilePath "BMD File: " enabled:false text:"" width:250 align:#left
		button btnBrowse "Browse..." width:100 align:#center
		spinner spnBoneThickness "Bone Thickness:" range:[0,100,5] align:#left fieldwidth:50
		checkBox chkSaveAnim "Save Animations " checked:true width:250 align:#left
		button btnImport "Import" width:100 align:#center
 
 		on btnBrowse pressed do
		(
			local f = getOpenFileName types:"BMD (*.bmd)"
			if f != undefined then
			(
				fileType = getFilenameType f
				if fileType  == ".bmd" OR fileType == ".BMD" then
					txtFilePath.text = f
				else
					messageBox "Only BMD files are supported"
			)
		)

		on btnImport pressed do
		(
			if (txtFilePath.text == undefined OR txtFilePath.text == "") then
				messageBox "You must select a BMD file to import"
			else
			(
				Undo off 
				(
					btnImport.enabled = false
					bmd = BModel()
					bmd.Import txtFilePath.text spnBoneThickness.value chkSaveAnim.checked
					btnImport.enabled = true
				)
				
				Undo on ()
				
				DestroyDialog MaxBMDUI_Rollout
			)
		)
	)
	
	createDialog MaxBMDUI_Rollout 300 150

)
